﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace Issue7494
{
    public partial class WebForm1 : System.Web.UI.Page, ICallbackEventHandler
    {
        public const string MapDefaultIcon = "theme/default/img/marker.gif";

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                InMemoryFeatureLayer eachFeatureLayer = new InMemoryFeatureLayer();
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Bitmap;
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.Image = new GeoImage(System.Web.HttpContext.Current.Server.MapPath(MapDefaultIcon));
                Map1.DynamicOverlay.Layers.Add("PointLayer", eachFeatureLayer);
            }
        }

        public string GetCallbackResult()
        {
            return "";
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            var inMemoryFeatureLayer = Map1.DynamicOverlay.Layers["PointLayer"] as InMemoryFeatureLayer;
            MultipointShape eachPointContainerShape = new MultipointShape();
            eachPointContainerShape.Points.Add(new PointShape(-97.48242, 38.75977));
            inMemoryFeatureLayer.InternalFeatures.Add(new Feature(eachPointContainerShape));
        }
    }
}